<?php

/*
ver:1.0~20230219
官网网址：http://www.rstack.com.cn/
*/

use app\common\logic\RunMap;
use app\common\model\HostModel;
use think\Db;


define('virtualType', 'vhost');
define('moduleName', 'rstackvhost');

#function rstackvhost_idcsmartauthorize(){}N

// 配置数据
function rstackvhost_MetaData(){
	return ['DisplayName'=>'rstackvhost', 'APIVersion'=>'1.0', 'HelpDoc'=>'http://www.rstack.com.cn/docs?id=49'];
}


function rstackvhost_ConfigOptions(){
	return [
		[
			'type'=>'text', 
			'name'=>'数据中心ID', 
			'description'=>'数据中心ID自动轮询节点节点）',
			'key'=>'areaid'
		],
		[
			'type'=>'text', 
			'name'=>'节点ID', 
			'description'=>'计算节点ID(不填则自动分配)',
			'default'=>'3',
			'key'=>'nodeid',
		],
		[
			'type'=>'dropdown', 
			'name'=>'ASP脚本', 
			'description'=>'', 
			'options'=>[
			    '0'=>'不支持',
			    '1'=>'支持'
			    ],
			'default'=>'',
			'key'=>'aspscript',
		],
		[
			'type'=>'dropdown', 
			'name'=>'ASP.NET脚本', 
			'description'=>'', 
			'options'=>[
			    '0'=>'不支持',
			    '1'=>'支持'
			    ],
			'default'=>'',
			'key'=>'aspxscript',
		],
		[
			'type'=>'dropdown', 
			'name'=>'PHP脚本', 
			'description'=>'', 
			'options'=>[
			    '0'=>'不支持',
			    '1'=>'支持'
			    ],
			'default'=>'',
			'key'=>'phpscript',
		],
		[
			'type'=>'text', 
			'name'=>'赠送MYSQL', 
			'description'=>'MB(为0不赠送)',
			'default'=>'0',
			'key'=>'mysqlspace',
		],
		[
			'type'=>'text', 
			'name'=>'赠送MSSQL', 
			'description'=>'MB (为0不赠送)',
			'default'=>'0',
			'key'=>'mssqlspace',
		],
		[
			'type'=>'text', 
			'name'=>'CPU限制', 
			'description'=>'% （仅对独立池有效）',
			'default'=>'100',
			'key'=>'cpulimit',
		],
		[
			'type'=>'text', 
			'name'=>'空间容量', 
			'description'=>'MB',
			'default'=>'1024',
			'key'=>'diskspace',
		],
		[
			'type'=>'text', 
			'name'=>'域名绑定数', 
			'description'=>'个',
			'default'=>'20',
			'key'=>'bindingdomain',
		],
		[
			'type'=>'text', 
			'name'=>'IIS连接数', 
			'description'=>'个(推荐最小50以上)',
			'default'=>'200',
			'key'=>'maxconnections',
		],
		[
			'type'=>'text', 
			'name'=>'站点宽带', 
			'description'=>'Mbps(最小1)',
			'default'=>'1',
			'key'=>'maxbandwidth',
		],
		[
			'type'=>'text', 
			'name'=>'每月流量', 
			'description'=>'GB(0为不限制流量)',
			'default'=>'0',
			'key'=>'bwlimit',
		],
		[
			'type'=>'text', 
			'name'=>'站点池分配', 
			'description'=>'多少站共享一个池',
			'default'=>'1',
			'key'=>'apppoolnum',
		],
		[
			'type'=>'yesno', 
			'name'=>'IP开通模式', 
			'description'=>'勾选表示独立IP空间', 
			'default'=>'0',
			'key'=>'hostip',
		],
		[
			'type'=>'dropdown', 
			'name'=>'默认PHP版本', 
			'description'=>'', 
			'options'=>[
			    '5.2'=>'PHP5.2',
			    '5.3'=>'PHP5.3',
			    '5.4'=>'PHP5.4',
			    '5.5'=>'PHP5.5',
			    '5.6'=>'PHP5.6',
			    '7.0'=>'PHP7.0',
			    '7.1'=>'PHP7.1',
			    '7.2'=>'PHP7.2',
			    '7.3'=>'PHP7.3',
			    '7.4'=>'PHP7.4',
			    '8.1'=>'PHP8.1',
			    ],
			'default'=>'',
			'key'=>'phpversion',
		],
		[
			'type'=>'dropdown', 
			'name'=>'默认NET版本', 
			'description'=>'', 
			'options'=>[
			    '2.0'=>'2.0/3.5',
			    '4.0'=>'4.0'
			    ],
			'default'=>'',
			'key'=>'netversion',
		],
		[
			'type'=>'dropdown', 
			'name'=>'NET池模式', 
			'description'=>'', 
			'options'=>[
			    '0'=>'经典(推荐)',
			    '1'=>'集成'
			    ],
			'default'=>'',
			'key'=>'netmode',
		],
		[
			'type'=>'dropdown', 
			'name'=>'开通后显示IP或CNAME', 
			'description'=>'CNAME的话方便以后换IP', 
			'options'=>[
			    'cname'=>'CNAME',
			    'ip'=>'IP地址'
			    ],
			'default'=>'',
			'key'=>'netmode',
		],
	
	];
}

// 连接测试
function rstackvhost_TestLink($params){
    $data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "test";

	$rsret = rstackvhost_post($url,$header,$data);
    $ret = rstackvhost_CheckReturn($rsret);
	if ($ret["code"]=="0"){
	    $result['status'] = 200;
		$result['data']['server_status'] = 1;
		
	}else{
	    $result['status'] = 200;
		$result['data']['server_status'] = 0;
		$result['data']['msg'] = $ret["msg"];
	}
	return $result;
}

// 图表
function rstackvhost_Chart_NOP(){
	return [
// 		'cpu'=>[
// 			'title'=>'CPU',
// 		],
		/*
		'disk'=>[
			'title'=>'磁盘IO',
			'select'=>[
				[
					'name'=>'系统盘',
					'value'=>'vda'
				],
				[
					'name'=>'数据盘',
					'value'=>'vdb'
				],
			]
		],
		*/
// 		'disk'=>[
// 			'title'=>'磁盘IO'
// 		],
		'flow'=>[
			'title'=>'流量图'
		],
		
	];
}

// 图表数据
function rstackvhost_ChartData_NOP($params){
    
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return ['status'=>'error', 'msg'=>'数据获取失败'];
	}
	
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "vhost_monitor";
    $data["hostid"]= $vserverid;

	$rsret = rstackvhost_post($url,$header,$data);
	
	$ret = rstackvhost_CheckReturn($rsret);
	
	
	if ($ret["code"]=="-1"){
	    //获取数据错误
	    return ['status'=>'error', 'msg'=>$ret["msg"]];
	}
	
	$rsret2 = json_decode($rsret,true);

	$start = $params['chart']['start']/1000;
	
	$result['status'] = 'success';
	$result['data'] = [];
    if($params['chart']['type'] == 'flow'){

		$result['data']['unit'] = 'KB/s';
		$result['data']['chart_type'] = 'line'; //area
		$result['data']['list'] = [];
		$result['data']['label'] = ['进(KB/s)','出(KB/s)'];

		foreach($rsret2 as $v){
			$time = $v["time"];
			$date = date('Y-m-d H:i:s', $time);
			$result['data']['list'][0][] = [
				'time'=>$date,
				'value'=>explode(",",$v["network"])[0]
			];
			$result['data']['list'][1][] = [
				'time'=>$date,
				'value'=>explode(",",$v["network"])[1]
			];
		}
	}
	
	return $result;
    
	
}

// 标准输出
function rstackvhost_ClientArea($params){
    return ["login" => ["name" => "控制面板"]];
    /*
	if(empty($params['configoptions']['portmap'])){
		unset($panel['portmap']);
	}
	if(empty($params['configoptions']['binding_domain'])){
		unset($panel['binding_domain']);
	}
	if(empty($params['configoptions']['backup_snapshot'])){
		unset($panel['backup_snapshot']);
	}
	if(empty($params['configoptions']['backup_full'])){
		unset($panel['backup_full']);
	}
	return $panel;
	*/
}

// 输出内容
function rstackvhost_ClientAreaOutput($params, $key){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return '';
	}
	if($key == 'login'){
	    //return ["template" => "templates/login.html", "vars" => ["name" => $params["name"], "address" => $params["server_host"], "username" => $temp["vpsname"], "password" => $temp["vpspassword"], "ip" => $temp["ip"], "status" => $temp["status"], "endtime" => $endtime, "api" => $params["configoptions"]["api"]]];
	
	    $data = rstackvhost_sign($params["server_password"]);
        $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
        $header = array();
        $data["action"] = "vhost_data";
        $data["id"] = $vserverid;
    	$rsret = rstackvhost_post($url,$header,$data);
    	$rsret2 = json_decode($rsret,true);
//     	foreach($rsret2 AS $k=>$v){
// 			$rsret2[$k]['time'] = date("Y-m-d H:i:s",strtotime($v['time']));
// 		}

        $statueMsg = "";
        $status = $rsret2["status"];
        if ($status =="1"){
            $statueMsg = "已锁定！";
        }else if ($status =="-1"){
            $statueMsg = "服务中止";
        }else if ($status =="-2"){
            $statueMsg = "超流量运行";
        }else if ($status =="-3"){
            $statueMsg = "超流量停止";
        }else if ($status =="2"){
            //$statueMsg = "过期停止！";
            $data = rstackvhost_sign($params["server_password"]);
            $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
            $header = array();
            $data["action"] = "state";
            $data["hostid"] = $vserverid;
        	$rsret = rstackvhost_post($url,$header,$data);
        	$ret = rstackvhost_CheckReturn($rsret);
        	if ($ret["code"]=="-1"){
        	    $statueMsg ="获取主机状态失败：".$res['msg'];
        	}else{
        	    $state_code  = explode("|",$rsret)[0];
        	    if ($state_code == "running"){
        	         $statueMsg = "站点运行中";
        	    }else if ($state_code == "off"){
        	        $statueMsg = "站点停止中";
        	    }else if ($state_code == "overbw"){
        	        $statueMsg = "超流量停机";
        	    }else if ($state_code == "overdue"){
        	       $statueMsg = "中止服务！";
        	    }else  if ($sta == "locked"){
        	        $statueMsg = "主机已锁定！";
        	    }else  if ($sta == "unknown"){
        	       $statueMsg = "未知状态";
        	    }else{
        	        $statueMsg = $state_code;
        	    }
        	}
        }
        
        $usedisk = "";
        $usedisk = "已使用容量：".($rsret2["diskspace_use"] / 1024)."MB / 总空间容量：".$rsret2["diskspace"]."MB";
        $hostip = $rsret2["hostip"];
        if ($rsret2["cname"] != ""){
            $hostip .= " / CNAME别名解析：".$rsret2["cname"];
        }

		return [
			'template'=>'templates/login.html',
			'vars'=>[
				'vhost_data'=>$rsret2,
				'name'=>$params["name"],
				'address'=>$params["address"],
				'username'=>$rsret2["ftpname"],
				'password'=>$rsret2["ftppassword"],
				'ip'=>$hostip,
				'status'=>$statueMsg,
				'api'=>str_replace("/api/v3","",$url),
				'ftpport'=>$rsret2["ftpport"],
				'usedisk'=>$usedisk,
			]
		];
	}

}

// 可以执行自定义方法
function rstackvhost_AllowFunction(){
	return [
		'client'=>['CreateSnap','DeleteSnap','RestoreSnap','CreateBackup','DeleteBackup','RestoreBackup','CreateSecurityGroup','DeleteSecurityGroup','ApplySecurityGroup','ShowSecurityGroupAcl','CreateSecurityGroupAcl','DeleteSecurityGroupAcl','MountCdRom','UnmountCdRom','addNatAcl','delNatAcl','addNatWeb','delNatWeb'],
	];
}

// 开通
function rstackvhost_CreateAccount($params){
	// 获取自定义字段
	$vserverid = rstackvhost_GetServerid($params);
	if(!empty($vserverid)){
		return '已开通,不能重复开通';
	}
	$domain = $params['domain'];
	$domains = "";
	if (strpos($domain,'.')!= false){
    	$domains = $domain;
    }
	$ftpusername = $params['username']; //rstackvhost_GetRandStr
	if ($ftpusername ==""){
	    $ftpusername = "vhost".strtolower(rstackvhost_GetRandStr(8));
	}
	$ftppassword = "";
	if(empty($params['password'])){
		$ftppassword = randStr(14);
	}else{
		$ftppassword = $params['password'];
	}
	
	$ftppassword2 = randStr(14);

	//查询RSTACK主控和注册账号：
	$uid = $params['uid']; 
	$username = ($params['user_info']['phonenumber'] ?: $params['user_info']['email']) ?: $params['user_info']['username']; //手机>邮箱>用户名
	$username2 = $username;
	$email = "";
	if (stripos($username,"@") > -1){
	    //用户名是邮箱：
	    $email = $username;
	    $username = str_replace("@","",$username);
	    $username = str_replace(".","",$username);
	}else{
	    $email = $username."@qq.com";
	}
	
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "user_info";
    $data["userid"] = $uid;

	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	if ($ret["code"] == "-1"){
	    return ['status'=>'error', 'msg'=>$ret['msg'] ?: '开通失败,原因查询用户失败'];
	}
	
	if ($rsret == ""){
	     $data["action"] = "user_add";
         $data["userid"] = $uid;
         $data["username"] = $username;
         $data["password"] = $ftppassword2;
         $data["email"] = $email;
         $data["status"] = "0";
    	$rsret = rstackvhost_post($url,$header,$data);
    	$ret = rstackvhost_CheckReturn($rsret);
		if ($ret["code"] == "-1"){
            return ['status'=>'error', 'msg'=>$ret['msg'] ?: '开通失败,原因注册用户失败'];
        }
	}
	
	$post_data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    
    $enable_mysql = "0";
    $mysqlbackupnum = "5"; //默认5个备份
    $enable_mssql = "0";
    $mssqlbackupnum = "5";
    
    $mysqlspace = $params['configoptions']['mysqlspace']; //mysql
    $mssqlspace = $params['configoptions']['mssqlspace']; //sql server
    $header = array();
    
    if ($mysqlspace != "0"){
        $enable_mysql ="1";
    }
    if ($mssqlspace !="0"){
        $enable_mssql ="1";
    }
    
    $tmp1  = explode(",",$mysqlspace);
    $tmp2  = explode(",",$mssqlspace);
    
    //如果MYSQL 带,如格式 50,3 那么代表SQL容量50M最大可备份3个
    if (count(tmp1) == 2){
        $mysqlspace = tmp1[0];
        $$mysqlbackupnum = tmp1[1];
    }
    if (count(tmp2) == 2){
        $mssqlspace = tmp2[0];
        $mssqlbackupnum = tmp2[1];
    }

    $post_data["action"] = "vhost_create";

	//$post_data = [];
	$post_data['userid'] = $uid; 
	$post_data['areaid'] = $params['configoptions']['areaid'];
	$post_data['nodeid'] = $params['configoptions']['nodeid'];
	$post_data['ftpname'] = $ftpusername; //$params['domain'];
	$post_data['ftppassword'] = $ftppassword;
	$post_data['aspscript'] = $params['configoptions']['aspscript'];

	$post_data['phpscript'] = $params['configoptions']['phpscript'];

	$post_data['aspxscript'] = $params['configoptions']['aspxscript'];
	
	$post_data['enable_mysql'] = $enable_mysql;
	$post_data['mysqlspace'] = $mysqlspace;
	$post_data['mysqlbackupnum']= $mysqlbackupnum;
	$post_data['enable_mssql'] = $enable_mssql;
	$post_data['mssqlspace'] = $mssqlspace;
	$post_data['mssqlbackupnum'] = $mssqlbackupnum;
	
	$post_data['domains'] = $domains;
	$post_data['cpulimit'] = $params['configoptions']['cpulimit'];
	$post_data['diskspace'] = $params['configoptions']['diskspace'];
	$post_data['bindingdomain'] = $params['configoptions']['bindingdomain'];
	$post_data['maxconnections'] = $params['configoptions']['maxconnections'];
	$post_data['bwlimit'] = $params['configoptions']['bwlimit'];
	$post_data['maxbandwidth'] = $params['configoptions']['maxbandwidth'];

	$post_data['apppoolnum'] = $params['configoptions']['apppoolnum'];
	$hostip = $params['configoptions']['hostip'];
	if ($hostip =="0"){
	    $hostip ="";
	}
	$post_data['hostip'] = $hostip;
	$post_data['phpversion'] = $params['configoptions']['phpversion'];
	$post_data['netversion'] = $params['configoptions']['netversion'];
	$post_data['netmode'] = $params['configoptions']['netmode'];
	$post_data['remark'] = "ZJMF[".$username2."].创建";
	$post_data['returnjson'] = "1";
 
	if(!empty($params['configoptions']['nodeid'])){
		$post_data['nodeid'] = $params['configoptions']['nodeid'];
	}
	
	
	
	$rsret = rstackvhost_post($url,$header,$post_data);

	$ret = rstackvhost_CheckReturn($rsret);
	
	$tmp  = explode("|",$rsret);
	$rsJSON = json_decode($tmp[1]); 
	
	if ($ret["code"]=="0"){
	    
	    //return ['status'=>'success', 'msg'=>"创建OK2"];
	    //return ['status'=>'error', 'msg'=>$rsret ?: '开通失33败'];
		// 存入产品自定义字段
		$customid = Db::name('customfields')
					->where('type', 'product')
					->where('relid', $params['productid'])
					->where('fieldname', 'vserverid')
					->value('id');
		if(empty($customid)){
			// 添加自定义字段
			$customfields = [
				'type'=>'product',
				'relid'=>$params['productid'],
				'fieldname'=>'vserverid',
				'fieldtype'=>'text',
				'adminonly'=>1,
				'create_time'=>time()
			];
			$customid = Db::name('customfields')->insertGetId($customfields);
		}
		$exist = Db::name('customfieldsvalues')
				->where('fieldid', $customid)
				->where('relid', $params['hostid'])
				->find();
		if(empty($exist)){
			$data = [
				'fieldid'=>$customid,
				'relid'=>$params['hostid'],
				'value'=>$rsJSON->id,
				'create_time'=>time()
			];
			Db::name('customfieldsvalues')->insert($data);
		}else{
			Db::name('customfieldsvalues')->where('id', $exist['id'])->update(['value'=>$rsJSON->id]);
		}
		// 存入IP
		$mainip = $rsJSON->hostip;
		$ftpport = $rsJSON->ftpport;
		// 获取当前操作系统
		$os_info = Db::name('host_config_options')
                    ->alias('a')
                    ->field('c.option_name')
                    ->leftJoin('product_config_options b', 'a.configid=b.id')
                    ->leftJoin('product_config_options_sub c', 'a.optionid=c.id')
                    ->where('a.relid', $params['hostid'])
                    ->where('b.option_type', 5)
                    ->find();
        /*
        if(stripos($os_info['option_name'], 'win') !== false){
            $username = 'administrator';
        }else{
            $username = 'root';
        }
        */
		$update['dedicatedip'] = $mainip;
		//$update['assignedips'] = $otherip;//implode(',', $ip);
		$update['port'] = $ftpport;
		// 存入服务器密码
		$update['domainstatus'] = 'Active';
		$update['username'] = $ftpusername;
		$update['password'] = cmf_encrypt($ftppassword);
		$update['domain'] = $rsJSON->$domain;

  		$update['bwlimit'] = (int)$post_data['bwlimit'];
		Db::name('host')->where('id', $params['hostid'])->update($update);
		//return 'ok';
		return ['status'=>'success', 'msg'=>"rstack创建模块完成！"];
	}else{
		return ['status'=>'error', 'msg'=>$ret['msg'] ?: '开通失败'];
	}
}

// 暂停
function rstackvhost_SuspendAccount($params){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return 'rstackID错误';
	}
	
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "vhost_update";
    $data["id"]= $vserverid;
    $data["update_host"] ="1"; //=1操作被控，否则=0只更改数据库
    $data["status"] ="1"; //主机状态（1=锁定，2=正常，-1=中止，-2=超流量运行，-3=超流量停止）

	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	
	if ($ret["code"]=="0"){
		return ['status'=>'success', 'msg'=>"暂停主机完成"];
	}else{
	   return ['status'=>'error', 'msg'=>$ret['msg'] ?: '暂停失败'];
	}
}

// 解除暂停
function rstackvhost_UnsuspendAccount($params){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return 'rstackID错误';
	}
	
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

	$data["action"] = "vhost_update";
    $data["id"]= $vserverid;
    $data["update_host"] ="1"; //=1操作被控，否则=0只更改数据库
    $data["status"] ="2"; //主机状态（1=锁定，2=正常，-1=中止，-2=超流量运行，-3=超流量停止）


	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	
	if ($ret["code"]=="0"){
	    return ['status'=>'success', 'msg'=>"解除暂停完成"];
	}else{
	   return ['status'=>'error', 'msg'=>$ret['msg'] ?: '修改状态>解除暂停失败'];
	}
}

// 删除
function rstackvhost_TerminateAccount($params){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return 'rstackID错误';
	}
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "vhost_delete";
    $data["hostid"]= $vserverid;
    $data["forcedelete"] = "1"; //强制删除

	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	
	if ($ret["code"]=="0"){
		// 删除成功后
		$customid = Db::name('customfields')
					->where('type', 'product')
					->where('relid', $params['productid'])
					->where('fieldname', 'vserverid')
					->value('id');
		Db::name('customfieldsvalues')->where('fieldid', $customid)->where('relid', $params['hostid'])->delete();
		// Db::name('host')->where('id', $params['hostid'])->update(['dedicatedip'=>'','assignedips'=>'','password'=>'']);
		return ['status'=>'success', 'msg'=>"删除完成"];
	}else{
		return ['status'=>'error', 'msg'=>$ret['msg'] ?: '删除失败'];
	}
}


function encode($str){
    $result = "";
    $addstr = "";
    $bytes = array();
    for ($i = 0;$i < strlen($str);$i++){
        $bytes[] = ord($str[$i]);
        $addstr .= chr($bytes[$i]+2);
    }
    $result = $addstr;
    return $result;
}

// 破解密码
function rstackvhost_CrackPassword($params, $new_pass){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return 'rstackID错误';
	}
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();
    
    //$password = $params["password"]; //初始得到表单密码
    $new_ftppassword = $new_pass; //随机密码

    $data["action"] = "set_ftppassword";
    $data["new_ftppassword"] = $new_ftppassword;
    $data["hostid"] = $vserverid;

	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	if ($ret["code"]=="0"){
	    $update['password'] = $new_ftppassword;
	    Db::name('host')->where('id', $params['hostid'])->update($update);
	    return ['status'=>'success', 'msg'=>'FTP密码修改成功'];
	}else{
	    
	    return ['status'=>'error', 'msg'=>$ret['msg'] ?: '修改密码失败'];
	}
}

// 续费
function rstackvhost_Renew($params){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return 'rstackID错误';
	}
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "vhost_update";
    $data["id"] = $vserverid;
    $data["status"]="2";//修改正常服务；
    $data["update_host"]="1";
    

	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	if ($ret["code"]=="0"){
	    return ['status'=>'success', 'msg'=>'续费成功！'];
	}else{
	    
	    return ['status'=>'error', 'msg'=>$ret['msg'] ?: '续费调用rstack失败！'];
	}
}

// 同步
function rstackvhost_Sync($params){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return 'rstackID错误';
	}

	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "vhost_data";
    $data["id"] = $vserverid;

	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	
	$rsret2 = json_decode($rsret,true);

	if ($rsret2["id"] != ""){
	    
	    $retJSON = json_decode($rsret,true);
	    $ftpname = $rsret2["ftpname"];
	    
	    
	    if ($ftpname != ""){
	        
	        $add_domain = "";
	        foreach($rsret2["domainlist"] as $item) { 
                $domainname = $item['domain']; 
                if ($add_domain ==""){
                    $add_domain = $domainname;
                }else{
                    $add_domain .=","+$domainname;
                }
            }
    	
    		//	return ['status'=>'error', 'msg'=>$ret['msg'] ?: $retJSON[0]["ip"]];
    		$update['dedicatedip'] = $rsret2["hostip"];
    		$update['assignedips'] = $add_domain;
    		$update['username'] = $rsret2["ftpname"];
    		$update['password'] = cmf_encrypt($rsret2['ftppassword']);
    		$update['domain'] = $add_domain; //$rsret2['freedomain'];
    		
    		$update["port"]=$rsret2["ftpport"];

      		$os_info = Db::name('host_config_options')
                        ->alias('a')
                        ->field('c.option_name')
                        ->leftJoin('product_config_options b', 'a.configid=b.id')
                        ->leftJoin('product_config_options_sub c', 'a.optionid=c.id')
                        ->where('a.relid', $params['hostid'])
                        ->where('b.option_type', 5)
                        ->find();
            
    		Db::name('host')->where('id', $params['hostid'])->update($update);
    		
    		return ['status'=>'success', 'msg'=>"同步完成！"];
    	}else{
    	    return ['status'=>'error', 'msg'=>"未找到rstack主机名" ?: '同步失败'];
    	    
    	}
	}else{
		return ['status'=>'error', 'msg'=>$ret['msg'] ?: '同步失败3'];
	}
}


// 升降级
function rstackvhost_ChangePackage($params){
    /*
    $result['status'] = 'error';
	$result['msg'] = "错误111";
	return $result;
	*/
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
	    # wyh 20201109 增
        $vserverid = intval($params['old_configoptions']['customfields']['vserverid']);
        if (empty($vserverid)){
            return 'rstackID错误';
        }
	}
	
	$post_data = [];
	$post_data = rstackvhost_sign($params["server_password"]);
	
	$post_data["update_vm"]="1";
    
	
	if(isset($params['configoptions_upgrade']['mysqlspace'])){
		$post_data['mysqlspace'] = $params['configoptions']['mysqlspace'];
	}
	if(isset($params['configoptions_upgrade']['mssqlspace'])){
		$post_data['mssqlspace'] = $params['configoptions']['mssqlspace'];
	}
	if(isset($params['configoptions_upgrade']['cpulimit'])){
		$post_data['cpulimit'] = $params['configoptions']['cpulimit'];
	}
	if(isset($params['configoptions_upgrade']['diskspace'])){
		$post_data['diskspace'] = $params['configoptions']['diskspace'];
	}
	if(isset($params['configoptions_upgrade']['port']) || isset($params['configoptions_upgrade']['bindingdomain'])){
		$post_data['port'] = $params['configoptions']['bindingdomain'] ?? $params['configoptions']['bindingdomain'];
	}
	
	//=========
	if(isset($params['configoptions_upgrade']['maxconnections'])){
		$post_data['maxconnections'] = $params['configoptions']['maxconnections'];
	}
	if(isset($params['configoptions_upgrade']['maxbandwidth'])){
		$post_data['maxbandwidth'] = $params['configoptions']['maxbandwidth'];
	}
	if(isset($params['configoptions_upgrade']['bwlimit'])){
		$post_data['bwlimit'] = $params['configoptions']['bwlimit'];
	}
	if(isset($params['configoptions_upgrade']['portmap'])){
		$post_data['portmap'] = $params['configoptions']['portmap'];
	}
	if(isset($params['configoptions_upgrade']['binding_domain'])){
		$post_data['binding_domain'] = $params['configoptions']['binding_domain'];
	}

	
	//$post_data['cpu'] = "6";
	
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $post_data["action"] = "vhost_update";
    $post_data["id"] = $vserverid;
    $post_data["status"] ="2";
    $post_data["vhost_update"]="1";

	$rsret = rstackvhost_post($url,$header,$post_data);

	$ret = rstackvhost_CheckReturn($rsret);
	
	if ($ret["code"]=="0"){
	    $result['status'] = 'success';
		$result['msg'] = $ret['msg'] ?: '升级配置成功';
	}else{
	    $result['status'] = 'error';
		$result['msg'] = $ret['msg'] ?: $ret["msg"];
	}

    # TODO wyh 20201105 新增 vserverid
    $pid = $params['productid'];
    $customid = Db::name('customfields')
        ->where('type', 'product')
        ->where('relid', $pid)
        ->where('fieldname', 'vserverid')
        ->value('id');

    if(empty($customid)){
        $customfields = [
            'type'=>'product',
            'relid'=>$pid,
            'fieldname'=>'vserverid',
            'fieldtype'=>'text',
            'adminonly'=>1,
            'create_time'=>time()
        ];
        $customid = Db::name('customfields')->insertGetId($customfields);
    }
    $exist = Db::name('customfieldsvalues')
        ->where('fieldid', $customid)
        ->where('relid', $params['hostid'])
        ->find();
    if(empty($exist)){
        $data = [
            'fieldid'=>$customid,
            'relid'=>$params['hostid'],
            'value'=>$vserverid??$vserverid,
            'create_time'=>time()
        ];
        Db::name('customfieldsvalues')->insert($data);
    }else{
        Db::name('customfieldsvalues')->where('id', $exist['id'])->update(['value'=>$vserverid??$vserverid]);
    }
    
    //升级完毕 拉取更新一次主控数据！
    rstackvhost_Sync($params);
    # 结束

	return $result;
}

// 云主机状态
function rstackvhost_Status($params){
	$vserverid = rstackvhost_GetServerid($params);
	if(empty($vserverid)){
		return 'rstackID错误2';
	}
	$data = rstackvhost_sign($params["server_password"]);
    $url = $params["secure"] ? "https://":"http://".$params["server_ip"]."/api/v3";
    $header = array();

    $data["action"] = "state";
    $data["hostid"] = $vserverid;

	$rsret = rstackvhost_post($url,$header,$data);

	$ret = rstackvhost_CheckReturn($rsret);
	
	if ($ret["code"]=="-1"){
	    return ['status'=>'error', 'msg'=>$res['msg'] ?: '获取失败'];
	}else{
	    $state_code  = explode("|",$rsret)[0];
	    
	    if ($state_code == "setupfailed"){
	         return ['status'=>'error', 'msg'=>"安装发生错误,请重新安装！" ?: '安装发生错误,请重新安装！'];
	    }
	    //魔方支持以下参数：
	    //on,off,suspend,waiting,process,unknown
	    //打开、关闭、挂起、等待、进程、未知
	    $result['status'] = 'success';
	    if ($state_code == "running"){
	       	$result['data']['status'] = 'on';
			$result['data']['des'] = '运行中';
	    }else if ($state_code == "off"){
	        $result['data']['status'] = 'off';
			$result['data']['des'] = '停止中';
	    }else if ($state_code == "overbw"){
	        $result['data']['status'] = 'off';
			$result['data']['des'] = '关机';
	    }else if ($state_code == "overdue"){
	        $result['data']['status'] = 'suspend';
			$result['data']['des'] = '到期关机';
	    }else  if ($sta == "locked"){
	        $result['data']['status'] = 'suspend';
			$result['data']['des'] = '锁定';
	    }else  if ($sta == "unknown"){
	        $result['data']['status'] = 'unknown';
			$result['data']['des'] = '未知状态';
	    }
	    
	    return $result;
	    
	}
}



// 后台按钮隐藏
function rstackvhost_AdminButtonHide($params){
	if(!empty(rstackvhost_GetServerid($params)) && $params['serverid']>0){
		return ['CreateAccount'];
	}else{
		return ['SuspendAccount','UnsuspendAccount','TerminateAccount','CrackPassword','Sync'];
	}
}

// 获取自定义字段value
function rstackvhost_GetServerid($params){
	return (int)$params['customfields']['vserverid'];
	// return Db::name('customfields')
	// 		->alias('a')
	// 		->leftJoin('customfieldsvalues b', 'a.id=b.fieldid')
	// 		->where('a.type', 'product')
	// 		->where('a.relid', $params['productid'])
	// 		->where('a.fieldname', 'vserverid')
	// 		->where('b.relid', $params['hostid'])
	// 		->value('value');
}


// 创建签名
function rstackvhost_CreateSign($token = ''){
	$res['api_timestamp'] =  time();
	$res['api_random'] = randStr(6); 
	$res['api_sign'] = strtolower(md5($token.$res['api_random'].$res['api_timestamp']));
	$res['api_type']= virtualType;
	$res['api_language'] = "chinese";
	return $res;
}

function rstackvhost_sign($apikey)
{
    $api_timestamp = time();
	$api_random = rstackvhost_GetRandStr(16);
    //加密MD5
	$api_sign = md5($apikey.$api_random.$api_timestamp);
    //返回sign签名
    return array(
        "api_sign"=>$api_sign,
        "api_timestamp"=>$api_timestamp,
        "api_random"=>$api_random,
        "api_language"=>"chinese",
        "api_type"=>virtualType
    );
}

function rstackvhost_GetRandStr($length){
    $str = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
    $len = strlen($str)-1;
    $randstr = '';
    for ($i=0;$i<$length;$i++) {
        $num=mt_rand(0,$len);
        $randstr .= $str[$num];
    }
    return $randstr;
}

function rstackvhost_CheckReturn($str){
	$tmp  = explode("|",$str);
	if (count($tmp)>2){
		return array(
			"code"=>"-1",
			"msg"=>"API返回格式不能出现多个|符号",
		);
	}else if (count($tmp) == 2){
		//带返回值 格式如  0|success
		return array(
			"code"=>$tmp[0],
			"msg"=>$tmp[1],
		);
	}else{
		if ($str == "0"){
			// 只返回 0 的接口
			return array(
				"code"=>$str,
				"msg"=>"",
			);
		}else{
			// 返回错误信息
			return array(
				"code"=>$tmp[0],
				"msg"=>$tmp[1],
			);
		}
	}
}
// 发送POST请求
function rstackvhost_post($url,$header,$data){
    $cUrl = curl_init();
    curl_setopt($cUrl, CURLOPT_URL, $url);//目标URL
    curl_setopt($cUrl, CURLOPT_TIMEOUT,600);//超时时间
    curl_setopt($cUrl, CURLOPT_POST, true);	//POST请求
    curl_setopt($cUrl, CURLOPT_POSTFIELDS, http_build_query($data));//POST数据
    curl_setopt($cUrl, CURLOPT_RETURNTRANSFER, 1);//设置接收返回值
    curl_setopt($cUrl, CURLOPT_HTTPHEADER, $header);//请求头
    curl_setopt($cUrl, CURLOPT_HEADER, true);//请求头
    curl_setopt($cUrl, CURLOPT_SSL_VERIFYPEER, FALSE);//不验证证书
    curl_setopt($cUrl, CURLOPT_SSL_VERIFYHOST, FALSE);//不验证HOSTS
    $output = curl_exec($cUrl); //发送
    $headerSize = curl_getinfo($cUrl, CURLINFO_HEADER_SIZE);//获取响应头长度
    $body = substr($output, $headerSize); //获取内容
    curl_close($cUrl);//释放curl资源
    return $body;
}


